/** 
 * (C) Copyright IBM Corp. 2011
 */
package $packageName$;

import com.ibm.pdp.engine.IMicroPattern;
import com.ibm.pdp.engine.ISimpleMicroPatternHandler;
import com.ibm.pdp.maf.rpp.pac.dataelement.DataElement;
import com.ibm.pdp.maf.rpp.service.IMAFModelService;
import com.ibm.pdp.maf.rpp.service.MAFModelService;

/**
 * This is a COBOL Micro Pattern that displays the label of a Data Element.
 * 
 * You can add those lines into your COBOL code.
 * 
      *{COBOL Project="MyProject" Package="MyPaclage"  Code="MyDECode"
      *} 
*/
public class  $className$  implements ISimpleMicroPatternHandler  {
		
		@Override
		public String getNamespace() {
			return null;
		}

		@Override
		public void init() {
		}

		/**
		 * Returns the identifier of the Micro Pattern.
		 * 
		 */
		@Override
		public String getId() {
			return "COBOL";
		}

		/**
		 * Called once per Micro Pattern having same ID and name space found in the source code
		 * 
		 * @param microPattern The Micro Pattern
		 * @return a String to replace the current Micro Pattern code in the source
		 */		
		@Override
		public String process(final IMicroPattern microPattern) {
			IMAFModelService mafService = MAFModelService.getInstance();
			String project = microPattern.getAttribute("Project");
			String pack = microPattern.getAttribute("Package");
			String code = microPattern.getAttribute("Code");
			if ( project == null || pack == null || code == null ) {
				microPattern.getProcessingContext().setStatus(
						IMicroPattern.WARNING_RAISED,
						microPattern.getLocation().getBeginIndex(),
						"Project/Package/Code Parameters not found!!!",
						"Please, review this Micro-Pattern declaration");
				return null;
			}
			
			// Retrieve the Data Element to display
			DataElement dataElement = mafService.getDataElement( project, pack, code);		
			if ( dataElement == null ) {
				microPattern.getProcessingContext().setStatus(
						IMicroPattern.WARNING_RAISED,
						microPattern.getLocation().getBeginIndex(),
						"Data Element not found!!!",
						"Please, review this Micro-Pattern declaration");
				return null;			
			}
			
			StringBuffer result = new StringBuffer();
			result.append(microPattern.getOriginalHeaderDeclaration());		
			result.append("       DISPLAY \"" + dataElement.getLabel() + "\".\n");
			result.append(microPattern.getClosingSequence());
			return result.toString();
		}
	}